/*
 * |-----------------------------------------------------------|
 * | Copyright (c) 1991, 1990 MIPS Computer Systems, Inc.      |
 * | All Rights Reserved                                       |
 * |-----------------------------------------------------------|
 * |          Restricted Rights Legend                         |
 * | Use, duplication, or disclosure by the Government is      |
 * | subject to restrictions as set forth in                   |
 * | subparagraph (c)(1)(ii) of the Rights in Technical        |
 * | Data and Computer Software Clause of DFARS 252.227-7013.  |
 * |         MIPS Computer Systems, Inc.                       |
 * |         950 DeGuigne Avenue                               |
 * |         Sunnyvale, California 94088-3650, USA             |
 * |-----------------------------------------------------------|
 */
#ident	"$Header: calloc.c,v 1.9.2.1 92/06/24 13:59:46 marker Exp $"

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*LINTLIBRARY*/
/*	calloc - allocate and clear memory block
*/
#define NULL 0
#include "shlib.h"

extern char *malloc(), *memset();
extern void free();

#if defined(__STDC__)

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned int    size_t;
#endif
void *calloc(size_t num, size_t size)

#else

char *
calloc(num, size)
unsigned num, size;

#endif
{
	register char *mp;

#if  defined(__STDC__)
	if ((num != 0) && (size != 0)) {
	    if((mp = malloc(num *= size)) != NULL) {
		    (void)memset(mp, 0, num);
	    }
	 }
	else
	    return(NULL);
#else  /* __STDC__ */
	if((mp = malloc(num *= size)) != NULL)
		(void)memset(mp, 0, num);
#endif /* __STDC__ */
	return(mp);
}

/*ARGSUSED*/
void
cfree(p, num, size)
char *p;
unsigned num, size;
{
	free(p);
}
